Gio::DBus::ActionGroup Class Reference

ActionGroup - A D-Bus Gio::ActionGroup implementation. More...

`#include <giomm/dbusactiongroup.h>`

Inheritance diagram for Gio::DBus::ActionGroup:
[legend]

## Public Member Functions

virtual | ~ActionGroup ()
GDBusActionGroup* | gobj ()
| Provides access to the underlying C GObject. More...
const GDBusActionGroup* | gobj () const
| Provides access to the underlying C GObject. More...
GDBusActionGroup* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Public Member Functions inherited from Glib::Object
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from Gio::ActionGroup
GActionGroup* | gobj ()
| Provides access to the underlying C GObject. More...
const GActionGroup* | gobj () const
| Provides access to the underlying C GObject. More...
bool | has_action (const Glib::ustring& action_name) const
| Checks if the named action exists within action_group. More...
std::vector< Glib::ustring > | list_actions () const
| Lists the actions contained within action_group. More...
bool | query_action (const Glib::ustring& action_name, bool& enabled, Glib::VariantType& parameter_type, Glib::VariantBase& state_hint, Glib::VariantType& state_type, Glib::VariantBase& state)
| Queries all aspects of the named action within an action_group. More...
bool | query_action (const Glib::ustring& action_name, bool& enabled, Glib::VariantType& parameter_type, Glib::VariantBase& state_hint, Glib::VariantType& state_type)
| A query_action() convenience overload. More...
bool | query_action (const Glib::ustring& action_name, bool& enabled, Glib::VariantType& parameter_type, Glib::VariantBase& state_hint, Glib::VariantBase& state)
| A query_action() convenience overload. More...
bool | query_action (const Glib::ustring& action_name, bool& enabled, Glib::VariantType& parameter_type, Glib::VariantBase& state_hint)
| A query_action() convenience overload. More...
bool | query_action (const Glib::ustring& action_name, bool& enabled, Glib::VariantBase& state_hint, Glib::VariantType& state_type, Glib::VariantBase& state)
| A query_action() convenience overload. More...
bool | query_action (const Glib::ustring& action_name, bool& enabled, Glib::VariantBase& state_hint, Glib::VariantType& state_type)
| A query_action() convenience overload. More...
bool | query_action (const Glib::ustring& action_name, bool& enabled, Glib::VariantBase& state_hint, Glib::VariantBase& state)
| A query_action() convenience overload. More...
bool | query_action (const Glib::ustring& action_name, bool& enabled, Glib::VariantBase& state_hint)
| A query_action() convenience overload. More...
bool | get_action_enabled (const Glib::ustring& action_name) const
| Checks if the named action within action_group is currently enabled. More...
Glib::VariantType | get_action_parameter_type (const Glib::ustring& action_name) const
| Queries the type of the parameter that must be given when activating the named action within action_group. More...
Glib::VariantType | get_action_state_type (const Glib::ustring& action_name) const
| Queries the type of the state of the named action within action_group. More...
Glib::VariantContainerBase | get_action_state_hint (const Glib::ustring& action_name) const
| Requests a hint about the valid range of values for the state of the named action within action_group. More...
template<typename T_Value >
void | get_action_state_hint (const Glib::ustring& action_name, T_Value&value) const
| Requests a hint about the valid range of values for the state of the named action within the action group. More...
Glib::VariantContainerBase | get_action_state_hint_variant (const Glib::ustring& action_name) const
| Requests a hint about the valid range of values for the state of the named action within action_group. More...
Glib::VariantBase | get_action_state (const Glib::ustring& action_name) const
| Queries the current state of the named action within action_group. More...
template<typename T_Value >
void | get_action_state (const Glib::ustring& action_name, T_Value&value) const
| Queries the current state of the named action within the action group. More...
Glib::VariantBase | get_action_state_variant (const Glib::ustring& action_name) const
| Queries the current state of the named action within action_group. More...
void | change_action_state (const Glib::ustring& action_name, const Glib::VariantBase&value)
| Request for the state of the named action within action_group to be changed to value. More...
void | activate_action (const Glib::ustring& action_name, const Glib::VariantBase& parameter)
| Activate the named action within action_group. More...
void | activate_action (const Glib::ustring& action_name)
| A activate_action() convenience overload. More...
void | action_added (const Glib::ustring& action_name)
| Emits the ActionGroup::signal_action_added() signal on action_group. More...
void | action_removed (const Glib::ustring& action_name)
| Emits the ActionGroup::signal_action_removed() signal on action_group. More...
void | action_enabled_changed (const Glib::ustring& action_name, bool enabled)
| Emits the ActionGroup::signal_action_enabled_changed() signal on action_group. More...
void | action_state_changed (const Glib::ustring& action_name, const Glib::VariantBase& state)
| Emits the ActionGroup::signal_action_state_changed() signal on action_group. More...
Glib::SignalProxy1< void, const Glib::ustring& > | signal_action_added ()
Glib::SignalProxy2< void, const Glib::ustring&, bool > | signal_action_enabled_changed ()
Glib::SignalProxy1< void, const Glib::ustring& > | signal_action_removed ()
Glib::SignalProxy2< void, const Glib::ustring&, const Glib::VariantBase& > | signal_action_state_changed ()
virtual bool | has_action_vfunc (const Glib::ustring& name) const
virtual std::vector < Glib::ustring > | list_actions_vfunc () const
virtual bool | get_action_enabled_vfunc (const Glib::ustring& name) const
virtual Glib::VariantType | get_action_parameter_type_vfunc (const Glib::ustring& name) const
virtual Glib::VariantType | get_action_state_type_vfunc (const Glib::ustring& name) const
virtual Glib::VariantBase | get_action_state_hint_vfunc (const Glib::ustring& name) const
virtual Glib::VariantBase | get_action_state_vfunc (const Glib::ustring& name) const
virtual void | change_action_state_vfunc (const Glib::ustring& name, const Glib::VariantBase&value)
virtual void | activate_action_vfunc (const Glib::ustring& name, const Glib::VariantBase& parameter)
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor. More...
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject* castitem)
| Called by constructors of derived classes. More...
virtual | ~Interface ()
GObject* | gobj ()
const GObject* | gobj () const
Public Member Functions inherited from Gio::RemoteActionGroup
virtual | ~RemoteActionGroup ()
GRemoteActionGroup* | gobj ()
| Provides access to the underlying C GObject. More...
const GRemoteActionGroup* | gobj () const
| Provides access to the underlying C GObject. More...
void | activate_action (const Glib::ustring& action_name, const Glib::VariantBase& parameter, const Glib::VariantBase& platform_data)
| Activates the remote action. More...
void | change_action_state (const Glib::ustring& action_name, const Glib::VariantBase&value, const Glib::VariantBase& platform_data)
| Changes the state of a remote action. More...
virtual void | activate_action_vfunc (const Glib::ustring& action_name, const Glib::VariantBase& parameter, const Glib::VariantBase& platform_data)
virtual void | change_action_state_vfunc (const Glib::ustring& action_name, const Glib::VariantBase&value, const Glib::VariantBase& platform_data)

## Static Public Member Functions

static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< ActionGroup > | get (const Glib::RefPtr< Connection >& connection, const Glib::ustring& bus_name, const Glib::ustring& object_path)
| Obtains a DBusActionGroup for the action group which is exported at the given bus_name and object_path. More...
Static Public Member Functions inherited from Gio::ActionGroup
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gio::RemoteActionGroup
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions

| ActionGroup ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
virtual | ~Object ()
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
virtual | ~ObjectBase ()=0
void | initialize (GObject* castitem)
Protected Member Functions inherited from Gio::ActionGroup
| ActionGroup ()
| You should derive from this class to use it. More...
virtual void | on_action_added (const Glib::ustring& action_name)
| This is a default handler for the signal signal_action_added(). More...
virtual void | on_action_enabled_changed (const Glib::ustring& action_name, bool enabled)
| This is a default handler for the signal signal_action_enabled_changed(). More...
virtual void | on_action_removed (const Glib::ustring& action_name)
| This is a default handler for the signal signal_action_removed(). More...
virtual void | on_action_state_changed (const Glib::ustring& action_name, const Glib::VariantBase&value)
| This is a default handler for the signal signal_action_state_changed(). More...
Protected Member Functions inherited from Gio::RemoteActionGroup
| RemoteActionGroup ()
| You should derive from this class to use it. More...

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr < Gio::DBus::ActionGroup > | wrap (GDBusActionGroup* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)
Related Functions inherited from Gio::ActionGroup
Glib::RefPtr< Gio::ActionGroup > | wrap (GActionGroup* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gio::RemoteActionGroup
Glib::RefPtr < Gio::RemoteActionGroup > | wrap (GRemoteActionGroup* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members

Public Types inherited from Glib::Object
typedef void(* | DestroyNotify )(gpointer data)

## Detailed Description

ActionGroup - A D-Bus Gio::ActionGroup implementation.

ActionGroup is an implementation of the Gio::ActionGroup interface that can be used as a proxy for an action group that is exported over D-Bus with Gio::DBus::Connection::export_action_group().

Since glibmm 2.32:

## Constructor & Destructor Documentation

virtual Gio::DBus::ActionGroup::~ActionGroup | ( |  | ) |

virtual

Reimplemented from Gio::ActionGroup.

Gio::DBus::ActionGroup::ActionGroup | ( |  | ) |

protected

## Member Function Documentation

static Glib::RefPtr<ActionGroup> Gio::DBus::ActionGroup::get | ( | const Glib::RefPtr< Connection >& | connection,
|  | const Glib::ustring& | bus_name,
|  | const Glib::ustring& | object_path
| ) |  |

static

Obtains a DBusActionGroup for the action group which is exported at the given bus_name and object_path.

The thread default main context is taken at the time of this call. All signals on the menu model (and any linked models) are reported with respect to this context. All calls on the returned menu model (and linked models) must also originate from this same context, with the thread default main context unchanged.

This call is non-blocking. The returned action group may or may not already be filled in. The correct thing to do is connect the signals for the action group to monitor for changes and then to call g_action_group_list_actions() to get the initial list.

Since glibmm 2.32:

Parameters

  connection | A DBusConnection.
  bus_name | The bus name which exports the action group.
  object_path | The object path at which the action group is exported.

Returns
  A DBusActionGroup.

static GType Gio::DBus::ActionGroup::get_type | ( |  | ) |

static

Get the GType for this class, for use with the underlying GObject type system.

GDBusActionGroup* Gio::DBus::ActionGroup::gobj | ( |  | ) |

inline

Provides access to the underlying C GObject.

const GDBusActionGroup* Gio::DBus::ActionGroup::gobj | ( |  | ) | const

inline

Provides access to the underlying C GObject.

GDBusActionGroup* Gio::DBus::ActionGroup::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::DBus::ActionGroup > wrap | ( | GDBusActionGroup * | object,
|  | bool | take_copy = `false`
| ) |  |

related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.